#include "Boards/hal.h"
#include "SerialCommunications/spi.h"
#include "driverlib.h"
#include "i2c_driver.h"

#ifndef VS_CODE
#pragma vector = USCI_B1_VECTOR
__interrupt void USCI_B1_ISR(void)
#else
void USCI_B1_ISR(void)
#endif
{
#ifdef I2C_USCI_INT_VECTOR
    if (UCB1CTL0 & UCMODE_3 == UCMODE_3)
    {
        // USCI module is in I2C Mode
        if (i2cISR(USCI_B1_BASE, UCB1IV))
        {
            __bic_SR_register_on_exit(LPM0_bits);
        }
    }
    else
    {
        // USCI module is in SPI mode
        if (spiISR(USCI_B1_BASE, UCB1IV))
        {
            __bic_SR_register_on_exit(LPM0_bits);
        }
    }
#else
    if (spiISR(USCI_B1_BASE, UCB1IV))
    {
        __bic_SR_register_on_exit(LPM0_bits);
    }
#endif
}

#ifndef VS_CODE
#pragma vector = USCI_A1_VECTOR
__interrupt void USCI_A1_ISR(void)
#else
void USCI_A1_ISR(void)
#endif
{
    // USCI module is in SPI mode
    if (spiISR(USCI_A1_BASE, UCA1IV))
    {
        __bic_SR_register_on_exit(LPM0_bits);
    }
}

#ifdef MPU

#ifndef VS_CODE
#pragma vector = USCI_B0_VECTOR
__interrupt void USCI_B0_ISR(void)
#else
void USCI_B0_ISR(void)
#endif
{
#ifdef I2C_USCI_INT_VECTOR
    if (UCB1CTL0 & UCMODE_3 == UCMODE_3)
    {
        // USCI module is in I2C Mode
        if (i2cISR(USCI_B0_BASE, UCB0IV))
        {
            __bic_SR_register_on_exit(LPM0_bits);
        }
    }
    else
    {
        // USCI module is in SPI mode
        if (spiISR(USCI_B0_BASE, UCB0IV))
        {
            __bic_SR_register_on_exit(LPM0_bits);
        }
    }
#else
    if (spiISR(USCI_B0_BASE, UCB0IV))
    {
        __bic_SR_register_on_exit(LPM0_bits);
    }
#endif
}

#ifndef VS_CODE
#pragma vector = USCI_A0_VECTOR
__interrupt void USCI_A0_ISR(void)
#else
void USCI_A0_ISR(void)
#endif
{
    // USCI module is in SPI mode
    if (spiISR(USCI_A0_BASE, UCA0IV))
    {
        __bic_SR_register_on_exit(LPM0_bits);
    }
}
#endif
